//Bibliotecas
#include <errno.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip_icmp.h>
#include <pwd.h>
#include <signal.h>
#include <stdio.h>
#include <sys/file.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

//definiciones globales
#define MAXHOSTNAME 80
#define BUFSIZE 1024

//declaracion de funcion
void end2();
//declaracion de variables globales
int s;
//incio del main
int main(int argc, char *argv[])
{
//declaracion de variables
	int port;
	int nfds, n, len, i;
    char hostname[80];
	char user[80];
    struct hostent *hp;
    struct sockaddr_in name;
	struct passwd *usuario;
	char buf[BUFSIZE];
	fd_set readfds;
//comprobacion de numerode argumentos
	if(argc != 3)
	{
		printf("Usage: mcc <mquina servidora> <puerto>\n");
		exit(0);
	}
	else
	{
		strcpy(hostname, argv[1]);
		port = atoi(argv[2]);
		printf("Se utlizara el Puerto n %d para establecer la conneccion\n", port);
	}
	usuario = getpwuid(geteuid());
	// Look up our host's network address.
    hp = gethostbyname(hostname);
    //Create a socket in the INET domain.
    s = socket(AF_INET, SOCK_STREAM, 0);
    //Create the address of the server.
    name.sin_family = AF_INET;
    name.sin_port = htons(port);
    memcpy(&name.sin_addr, hp->h_addr_list[0], hp->h_length);
    len = sizeof(struct sockaddr_in);
    //Connect to the server.
    connect(s, (struct sockaddr *) &name, len);
	signal(SIGINT, end2);
	if (send(s, usuario->pw_name, sizeof(usuario->pw_name), 0) < 0)
	{
		perror("send");
		exit(1);
	}
	if (send(s, ": \n", sizeof(": \n"), 0) < 0)
	{
		perror("send");
		exit(1);
	}

	//Read from standard input, and copy the data to the socket.
    while (1)
	{
		FD_ZERO(&readfds);
		FD_SET(s,&readfds);
		FD_SET(0,&readfds);
		nfds = select(FD_SETSIZE, &readfds, (fd_set *) 0, (fd_set *) 0, NULL);
		if (nfds > 0)
		{
			if(FD_ISSET(0, &readfds))
			{
				if((n = read(0, buf, sizeof(buf))) > 0)
				{
					if(buf[0] != '\n')
					{
						if (send(s, buf, n, 0) < 0)
						{
							perror("send");
							exit(1);
						}
					}
				}
			}
			if(FD_ISSET(s, &readfds))
			{
				n = recv(s, buf, sizeof(buf), 0);
				if (n == 0)
					break;
				else
					write(1, buf, n);
			}
		}
	}
	close(s);
	write(0,"El servidor a sido cerrado\n",sizeof("El servidor a sido cerrado\n"));
}

void end2(void)
{
    //Cerramos el socket de escucha.
    close(s);
	exit(1);
}