// Librerias Necesarias

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>

//variables globales
int lista_conectados[40];
char lista_mensaje[10][1024];
int listen_sd, conectados = 0, mensajes = 0, actual = 0, total = 0;
pthread_mutex_t conect, mensaje;

//declaracion de funciones
void *service(void *arg);
void *responder(void *arg);
void cleanup(int arg);
void end();

//inicio del programa
int main(int argc, char *argv[])
{
	//declaracion de variables del programa
    int port, yes = 1, i, j, serve_sd;
	struct protoent *ptrp;
    struct sockaddr_in sad;
	pthread_t service_tid;
	//comprobacion de numero de parametros
	if(argc > 2)
	{
		printf("Usage: mcs [puerto]\n");
		exit(0);
	}
	else
	{
		if(argc < 2)
		{
			printf("Puerto Asignado Automaticamente\n");
			port = 12345;
		}
		else
		{
			port = atoi(argv[1]);
		}
	}
	//impresion del puerto que se va a ocupar
	printf("Se utlizara el Puerto n %d para establecer la conneccion\n", port);

	// Un semforo para acceder "en exclusin mutua" a una zona de cdigo.
	pthread_mutex_init(&conect, NULL);
	pthread_mutex_init(&mensaje, NULL);

	//Creamos el socket TCP de escucha.
    // Obtenemos el nmero del protocolo.
    ptrp = getprotobyname("tcp");
    if((int)(ptrp) == 0)
	{
		perror("getprotobyname");
		exit(-1);
    }

    // Creamos el socket.
    listen_sd = socket (PF_INET, SOCK_STREAM, ptrp->p_proto);
    if(listen_sd < 0)
	{
		perror("socket");
		exit(-1);
    }

    //Usaremos el puerto de servicio sin esperar a que ste est libre.
    if(setsockopt(listen_sd, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int)) < 0)
	{
		perror("setsockopt");
		exit(EXIT_FAILURE);
    }

	//Asignamos una direccin (dir IP, puerto) al socket de escucha.
    //Direccin del servidor.
    memset((char  *)&sad,0,sizeof(sad)); //Borramos la estructura.
    sad.sin_family = AF_INET;            //Usaremos Internet.
    sad.sin_addr.s_addr = INADDR_ANY;    //Cualquiera de las IP asignadas al host vale.
    sad.sin_port = htons((u_short)port); // Asignamos el puerto de escucha.
    if (bind(listen_sd, (struct sockaddr *)&sad, sizeof (sad)) < 0)
	{
		perror("bind");
		exit(-1);
    }

	/* Comenzamos a escuchar. */
	if (listen(listen_sd, 1) < 0)
	{
		perror("listen");
		exit(EXIT_FAILURE);
	}
	printf("%s: esperando conexiones ...\n", argv[0]);

	// Si pulsamos CRTL+C, el programa acaba ejecutando la funcin end().
	//Lazo del servidor.
  	if(pthread_create(&service_tid, NULL, responder, (void *)serve_sd) == -1)
	{
		perror("pthread_create");
		exit(EXIT_FAILURE);
	}

	signal(SIGINT, end);
	while(1)
	{
		//Esperamos a que un cliente se conecte.
		struct sockaddr_in cad;        //Client's address.
		socklen_t alen = sizeof(cad);  //Tamao de la direccin.
		serve_sd = accept(listen_sd, (struct sockaddr *)&cad, &alen);
		if(serve_sd<0)
		{
			perror("accept");
			exit (EXIT_FAILURE);
		}
		printf("%s: conexin aceptada!\n",argv[0]);
		/* Hilo que controla a un cliente. */
		//Lanzamos el hilo.
		if(pthread_create(&service_tid, NULL, service, (void *)serve_sd) == -1)
		{
			perror("pthread_create");
			exit(EXIT_FAILURE);
		}
	}
	exit(1);
}

void end()
{
    //Cerramos el socket de escucha.
    close(listen_sd);
	exit(EXIT_SUCCESS);
}

void *service(void *arg)
{
	//El socket de conmunicacin con el cliente. Ntese que cada cliente posee una variable "sd" diferente.
	int largo, i, usu, num_conectado = -1, aux;
	char buf[1024];
	char usuario[80];
	int sd = (int)arg;
	pthread_mutex_lock(&conect);
	for(i = 0; i < conectados; i++)
		if(lista_conectados[i] == -1)
		{
			lista_conectados[i] = sd;
			num_conectado = i;
		}
	if(num_conectado == -1)
	{
		num_conectado = conectados;
		lista_conectados[conectados] = sd;
		conectados++;
	}
	pthread_mutex_unlock(&conect);
	usu = recv(sd, usuario, sizeof(usuario), 0);
	while(1)
	{
	    largo = recv(sd, buf, sizeof(buf), 0);
		if (largo == 0)
		{
			pthread_mutex_lock(&conect);
			lista_conectados[num_conectado] = -1;
			pthread_mutex_unlock(&conect);
			break;
		}
		if(largo > 0)
		{
			pthread_mutex_lock(&mensaje);
			if(mensajes < 11)
			{
				aux = (total++)%10;
				mensajes++;
			}
			else
				aux = -1;
			pthread_mutex_unlock(&mensaje);
			if(aux != -1)
			{
				strncpy(&lista_mensaje[aux][0],usuario, usu - 2);
				strncpy(&lista_mensaje[aux][usu - 1],buf,largo);
			}
		}

	}
	close(sd);
	pthread_exit(0);
}
//funcion para enviar mensajes a todos los clientes
void *responder(void *arg)
{
	int aux, aux2, i;
	while(1)
	{
		//aseguramos con semaforos la memoria compartida
		pthread_mutex_lock(&mensaje);
		aux = mensajes;
		pthread_mutex_unlock(&mensaje);
		//si hay por lo menos 1 cliente conectado enviamos el mesaje
		if(aux > 0)
		{
			//se recorre los conectados y se envia el mensaje
			for(i = 0; i < conectados; i++)
			{
				if((lista_conectados[i] != -1))
				{
					if (send(lista_conectados[i], &lista_mensaje[actual][0], sizeof(lista_mensaje[0]), 0) < 0)
					{
						perror("send");
						exit(1);
					}
					if (send(lista_conectados[i], "\n", sizeof("\n"), 0) < 0)
					{
						perror("send");
						exit(1);
					}
				}
			}
		cleanup(actual);
		actual = (++actual)%10;
		pthread_mutex_lock(&mensaje);
		mensajes--;
		pthread_mutex_unlock(&mensaje);
		}
	}
}

//limpia el mensaje o string para usar para el envio y recepcion de mensajes
void cleanup(int arg)
{
	int i;
	for(i = 0; i < 1024; i++)
		lista_mensaje[arg][i] = '\0';
}